(*
    SNU 4541.664A HW4 
*)
open Syn

structure Tcollect =
struct

type integer = Int of int | PInfty | NInfty
type address = Addr of string
type value = Adr of address list | Itv of integer * integer | Bottom
type evalue = Eval of value * value
exception Notnum of string

fun eval tpgm =
    let
		val emptymem = Map.empty
		val table = ref Map.empty
		fun tableadd t mem memtable =
			(Map.add t ((Map.find t memtable)@[mem]) memtable)
				handle _ => (Map.add t [mem] memtable)

		fun add((v1,_), (v2,_)) =
			case (v1, v2) of
				(Itv(Int(x1), Int(x2)), Itv(Int(y1),Int(y2))) => (Itv(Int(x1+y1),Int(x2+y2)),Bottom)
			|	(Itv(NInfty, Int(x2)), Itv(_,Int(y2))) => (Itv(NInfty,Int(x2+y2)),Bottom)
			|	(Itv(Int(x1), PInfty), Itv(Int(y1),_)) => (Itv(Int(x1+y1),PInfty),Bottom)
			|	(Itv(_, Int(x2)), Itv(NInfty,Int(y2))) => (Itv(NInfty,Int(x2+y2)),Bottom)
			|	(Itv(Int(x1), _), Itv(Int(y1),PInfty)) => (Itv(Int(x1+y1),PInfty),Bottom)
			|	(Itv(NInfty, _), Itv(_,PInfty)) => (Itv(NInfty,PInfty),Bottom)
			|	(Itv(_, PInfty), Itv(NInfty,_)) => (Itv(NInfty,PInfty),Bottom)
			|	(Itv(NInfty, PInfty), Itv(_,_)) => (Itv(NInfty,PInfty),Bottom)
			|	(Itv(_,_), Itv(NInfty,PInfty)) => (Itv(NInfty,PInfty),Bottom)
			|	(Bottom, _) => (Bottom,Bottom)
			|	(_,Bottom) => (Bottom,Bottom)
			|	(_, _) => (Itv(NInfty,PInfty),Bottom)
		fun eq((v1,_), (v2,_)) =
			case (v1, v2) of
				(Itv(Int(x1),Int(x2)), Itv(Int(y1),Int(y2))) =>
									if ((x1 = x2) andalso (y1 = y2)) andalso (x1 = y1)
									then Itv(Int(1),Int(1))
									else if (x1 > y2) orelse (y1 > x2)
									then Itv(Int(0),Int(0)) else Itv(NInfty,PInfty)
			|	(Itv(NInfty,Int(x2)), Itv(Int(y1),_)) =>
									if (y1 > x2)
									then Itv(Int(0),Int(0)) else Itv(NInfty,PInfty)
			|	(Itv(Int(x1),_), Itv(NInfty,Int(y2))) =>
									if (x1 > y2)
									then Itv(Int(0),Int(0)) else Itv(NInfty,PInfty)
			|	(Itv(Int(x1),PInfty), Itv(_,Int(y2))) =>
									if (x1 > y2)
									then Itv(Int(0),Int(0)) else Itv(NInfty,PInfty)
			|	(Itv(_,Int(x2)), Itv(Int(y1),PInfty)) =>
									if (y1 > x2)
									then Itv(Int(0),Int(0)) else Itv(NInfty,PInfty)
			|	(Itv(NInfty,PInfty),Itv(_,_)) => Itv(NInfty,PInfty)
			|	(Itv(_,_),Itv(NInfty,PInfty)) => Itv(NInfty,PInfty)
			|	(Bottom, _) => Bottom
			|	(_,Bottom) => Bottom
			|	(_, _) => Itv(NInfty,PInfty)
		fun lt((v1,_), (v2,_)) =
			case (v1, v2) of
				(Itv(Int(x1),Int(x2)), Itv(Int(y1),Int(y2))) =>
											if x2 < y1
											then Itv(Int(1),Int(1))
											else if x1 < y2
												then Itv(NInfty,PInfty)
												else Itv(Int(0),Int(0))
			|	(Itv(_,Int(x2)), Itv(Int(y1),_)) =>
											if x2 < y1
											then Itv(Int(1),Int(1))
											else Itv(NInfty,PInfty)
			|	(Itv(Int(x1),_), Itv(_,Int(y2))) =>
											if x1 >= y2
											then Itv(Int(0),Int(0))
											else Itv(NInfty,PInfty)
			|	(Itv(NInfty,PInfty),Itv(_,_)) => Itv(NInfty,PInfty)
			|	(Itv(_,_),Itv(NInfty,PInfty)) => Itv(NInfty,PInfty)
			|	(Bottom, _) => Bottom
			|	(_, Bottom) => Bottom
			|	(_, _) => Itv(NInfty,PInfty)
		fun numand(v1, v2) =
			case (v1, v2) of
				(Itv(Int(x1),Int(x2)), Itv(Int(y1),Int(y2))) =>
									if (x1 <> 0 orelse x2 <> 0) andalso (y1 <> 0 orelse y2 <> 0)
									then Itv(Int(1),Int(1)) else Itv(Int(0),Int(0))
			|	(Itv(NInfty,PInfty),Itv(Int(y1),Int(y2))) =>
									if (y1 <> 0 orelse y2 <> 0)
									then Itv(NInfty,PInfty) else Itv(Int(0),Int(0))
			|	(Itv(Int(x1),Int(x2)),Itv(NInfty,PInfty)) =>
									if (x1 <> 0 orelse x2 <> 0)
									then Itv(NInfty,PInfty) else Itv(Int(0),Int(0))
			|	(Itv(NInfty,PInfty),Itv(NInfty,PInfty)) =>
									Itv(NInfty,PInfty)
			|	(Bottom,_) => Bottom
			|	(_,Bottom) => Bottom
			|	(_, _) => Itv(NInfty,PInfty)
		fun neg(v1,_) =
			case v1 of
				Itv(Int(x1), Int(x2)) => (Itv(Int(-x2), Int(-x1)),Bottom)
			|	Itv(NInfty, Int(x2)) => (Itv(Int(-x2), PInfty),Bottom)
			|	Itv(Int(x1), PInfty) => (Itv(NInfty, Int(-x1)),Bottom)
			|	Itv(NInfty, PInfty) => (v1,Bottom)
			|	Bottom => (Bottom, Bottom)
			|	_ => (Itv(NInfty,PInfty),Bottom)
		fun memadd x y mem =
			case x of
				Addr(_) => (Map.add x y mem)
			|	_ => mem
		fun memfind x mem =
			case x of
				Addr(_) => (Map.find x mem) handle Not_found => (Bottom,Bottom)
			|	_ => (Bottom, Bottom)
		fun intjoin x y =
			case (x, y) of
				(Itv(Int(x1),Int(x2)), Itv(Int(y1),Int(y2))) =>
									let val l = if x1 < y1 then x1 else y1
										val h = if x2 > y2 then x2 else y2 
									in
									Itv(Int(l),Int(h))
									end
			|	(Itv(NInfty, Int(x2)), Itv(_, Int(y2))) =>
									let val h = if x2 > y2 then x2 else y2
									in
									Itv(NInfty, Int(h))
									end
			|	(Itv(_, Int(x2)), Itv(NInfty, Int(y2))) =>
									let val h = if x2 > y2 then x2 else y2
									in
									Itv(NInfty, Int(h))
									end
			|	(Itv(Int(x1), PInfty), Itv(Int(y1), _)) =>
									let val l = if x1 < y1 then x1 else y1
									in
									Itv(Int(l), PInfty)
									end
			|	(Itv(Int(x1), _), Itv(Int(y1), PInfty)) =>
									let val l = if x1 < y1 then x1 else y1
									in
									Itv(Int(l), PInfty)
									end
			|	(Itv(NInfty, _), Itv(_, PInfty)) => Itv(NInfty, PInfty)
			|	(Itv(_, PInfty), Itv(NInfty, _)) => Itv(NInfty, PInfty)
			|	(Itv(NInfty, PInfty), Itv(_, _)) => Itv(NInfty, PInfty)
			|	(Itv(_, _), Itv(NInfty, PInfty)) => Itv(NInfty, PInfty)
			|	(Bottom, _) => y
			|	(_, Bottom) => x
			|  _ => Itv(NInfty,PInfty)
		fun adrjoin x y =
			case (x, y) of
				(Adr(x1), Adr(x2)) => Adr((List.filter (fn k => not(List.mem k x2)) x1)@x2)
			|	(Bottom, _) => y
			|	(_, Bottom) => x
			|  _ => raise Notnum("adrjoin error")
		fun join (x1,x2) (y1,y2) = ((intjoin x1 y1),(adrjoin x2 y2))
		fun intmeet x y =
			case (x, y) of
				(Itv(Int(x1),Int(x2)), Itv(Int(y1),Int(y2))) =>
									let val l = if x1 < y1 then y1 else x1
										val h = if x2 > y2 then y2 else x2
									in
									if h >= l then Itv(Int(l),Int(h))
									else Bottom
									end
			|	(Itv(Int(x1),PInfty), Itv(Int(y1),Int(y2))) =>
									let val l = if x1 < y1 then y1 else x1
									in
									if y2 >= l then Itv(Int(l),Int(y2))
									else Bottom
									end
			|	(Itv(Int(x1),Int(x2)), Itv(Int(y1),PInfty)) =>
									let val l = if x1 < y1 then y1 else x1
									in
									if x2 >= l then Itv(Int(l),Int(x2))
									else Bottom
									end
			|	(Itv(NInfty,Int(x2)), Itv(Int(y1),Int(y2))) =>
									let val h = if x2 > y2 then y2 else x2
									in
									if h >= y1 then Itv(Int(y1),Int(h))
									else Bottom
									end
			|	(Itv(Int(x1),Int(x2)), Itv(NInfty,Int(y2))) =>
									let val h = if x2 > y2 then y2 else x2
									in
									if h >= x1 then Itv(Int(x1),Int(h))
									else Bottom
									end
			|	(Itv(NInfty,Int(x2)), Itv(Int(y1),PInfty)) =>
									if x2 >= y1 then Itv(Int(y1),Int(x2))
									else Bottom
			|	(Itv(Int(x1),PInfty), Itv(NInfty, Int(y2))) =>
									if y2 >= x1 then Itv(Int(x1),Int(y2))
									else Bottom
			|	(Itv(NInfty,Int(x2)), Itv(NInfty, Int(y2))) =>
									if x2 >= y2 then Itv(NInfty,Int(y2))
									else Itv(NInfty,Int(x2))
			|	(Itv(Int(x1),PInfty), Itv(Int(y1),PInfty)) =>
									if x1 >= y1 then Itv(Int(x1),PInfty)
									else Itv(Int(y1),PInfty)
			|	(Itv(NInfty,PInfty),Itv(Int(y1),Int(y2))) => y
			|	(Itv(Int(x1),Int(x2)),Itv(NInfty,PInfty)) => x
			|	(Bottom,_) => Bottom
			|	(_, Bottom) => Bottom
			|	_ => Bottom
		fun adrmeet x y =
			case (x,y) of
				(Adr(x1), Adr(x2)) => Adr(List.filter (fn k => List.mem k x2) x1)
			|	(Bottom,_) => Bottom
			|	(_, Bottom) => Bottom
			|	_ => raise Notnum("adrmeet error")
		fun meet (x1,x2) (y1,y2) = ((intmeet x1 y1),(adrmeet x2 y2))
		fun deref (_,x) mem =
			case x of
				Adr([h]) => (memfind h mem)
			|	Adr(h::tl) => (join (memfind h mem) (deref (Bottom,Adr(tl)) mem))
			|	_ => (Itv(NInfty,PInfty),Bottom)

		fun derefitr k r mem =
			case k of
				[h] => (memadd h (join (memfind h mem) r) mem)
			|	h::tl => (memadd h (join (memfind h mem) r) (derefitr tl r mem))
			|	_ => mem
		fun derefassign (_,l) r mem =
			case l of
				Adr([h]) => (memadd h r mem)
			|	Adr(k) => (derefitr k r mem)
			|	_ => mem
		fun memjoin mem1 mem2 =
			let
				val mem = ref Map.empty
				fun firstjoin k v =
					mem := (memadd k (join v ((memfind k mem2) handle _ => (Bottom,Bottom))) !mem)
				fun secondjoin k v =
					if (Map.mem k !mem)
					then ()
					else
						mem := (memadd k (join v (Bottom,Bottom)) !mem)
			in
				(Map.iter firstjoin mem1); (Map.iter secondjoin mem2); !mem
			end
		fun memmeet mem1 mem2 =
			let
				val mem = ref Map.empty
				fun firstmeet k v =
					mem := (memadd k (meet v ((memfind k mem2) handle _ => (Bottom,Bottom))) !mem)
				fun secondmeet k v =
					if (Map.mem k !mem)
					then ()
					else
						mem := (memadd k (meet v (Bottom,Bottom)) !mem)
			in
				(Map.iter firstmeet mem1); (Map.iter secondmeet mem2); !mem
			end
		fun widen mem1 mem2 =
			let
				val mem = ref mem2
				fun compare (v1,a) (v2,_) =
					case (v1, v2) of
						(Itv(Int(i1),Int(i2)),Itv(Int(j1),Int(j2)))
							=> if j1 < i1 andalso j2 > i2
								then (Itv(NInfty, PInfty),a)
								else if j1 < i1 andalso j2 = i2
									then (Itv(NInfty, Int(j2)),a)
									else if j1 = i1 andalso j2 > i2
										then (Itv(Int(j1),PInfty),a)
										else (Itv(Int(j1), Int(j2)),a)
					|	(Itv(NInfty,PInfty),Itv(_,_))
							=> (Itv(NInfty,PInfty),a)
					|	(Itv(NInfty,Int(i2)),Itv(_,Int(j2)))
							=> if j2 > i2
								then (Itv(NInfty,PInfty),a)
								else (Itv(NInfty,Int(j2)),a)
					|	(Itv(Int(i1),PInfty),Itv(Int(j1),_))
							=> if j1 < i1
								then (Itv(NInfty,PInfty),a)
								else (Itv(Int(j1),PInfty),a)
					|	(Itv(_,_),Itv(NInfty,PInfty))
							=> (Itv(NInfty,PInfty),a)
					|	(Itv(_,Int(i2)),Itv(NInfty,Int(j2)))
							=> if j2 > i2
								then (Itv(NInfty,PInfty),a)
								else (Itv(NInfty,Int(j2)),a)
					|	(Itv(Int(i1),_),Itv(Int(j1),PInfty))
							=> if j1 < i1
								then (Itv(NInfty,PInfty),a)
								else (Itv(Int(j1),PInfty),a)
					|	(Bottom, _) => (v1,a)
					|	_ => (v1,a)
				fun accel k v =
					mem := (memadd k (compare v (memfind k mem2)) !mem)
			in
				(Map.iter accel mem1); !mem
			end
		fun narrow mem1 mem2 =
			let
				val mem = ref mem2
				fun compare (v1,a) (v2,_) =
					case (v1, v2) of
						(Itv(Int(i1),Int(i2)),Itv(_,_))
							=> (Itv(Int(i1), Int(i2)),a)
					|	(Itv(NInfty,PInfty),Itv(Int(i),Int(j)))
							=> (Itv(Int(i),Int(j)),a)
					|	(Itv(NInfty,Int(i)),Itv(Int(j),_))
							=> (Itv(Int(j),Int(i)),a)
					|	(Itv(Int(i),PInfty),Itv(_,Int(j)))
							=> (Itv(Int(i),Int(j)),a)
					|	(Itv(i,j),Itv(_,_))
							=> (Itv(i,j),a)
					|	(Bottom, _) => (v1,a)
					|	_ => (v1,a)
				fun break k v =
					mem := (memadd k (compare v (memfind k mem2)) !mem)
			in
				(Map.iter break mem1); !mem
			end
		fun memequal mem1 mem2 =
			let
				val f = ref true
			in
				((Map.iter (fn x y => if (memfind x mem1) = y 
									then () else f := false) mem2)
				handle Not_found => f := false);
				!f
			end
		fun satisfy exp mem =
			case exp of
				Blop(Lt,Var(id),Num(n)) => 
					(memadd Addr(id) (meet (memfind Addr(id) mem) (Itv(NInfty,Int(n-1)),Bottom)) mem)
			|	Blop(Lt,Num(n),Var(id)) =>
					(memadd Addr(id) (meet (memfind Addr(id) mem) (Itv(Int(n+1),PInfty),Bottom)) mem)
			|	_ => mem
		fun notsatisfy exp mem =
			case exp of
				Blop(Lt,Var(id),Num(n)) => 
					(memadd Addr(id) (meet (memfind Addr(id) mem) (Itv(Int(n),PInfty),Bottom)) mem)
			|	Blop(Lt,Num(n),Var(id)) =>
					(memadd Addr(id) (meet (memfind Addr(id) mem) (Itv(NInfty,Int(n)),Bottom)) mem)
			|	_ => mem
		fun widening t exp cmd mem imem =
			table := (tableadd t mem !table);
			let
				val mem2 = (widen mem (memjoin imem (eval_cmd cmd (satisfy exp mem))))
			in
			if (memequal mem2 mem) then mem
			else (widening t exp cmd mem2 imem)
			end
		and narrowing t exp cmd mem imem =
			table := (tableadd t mem !table);
			let
				val mem2 = (narrow mem (memjoin imem (eval_cmd cmd (satisfy exp mem))))
			in
			if (memequal mem2 mem) then mem
			else (narrowing t exp cmd mem2 imem)
			end
        and eval_cmd tcmd mem =
            case tcmd of
                TSkip(t) => table := (tableadd t mem !table);mem
            |   TVarAssign(t,id,exp) => (table := (tableadd t mem !table);
										memadd Addr(id) (eval_exp exp mem) mem)
            |   TDerefAssign(t,id,exp) => table := (tableadd t mem !table);
					let
						val r = (eval_exp exp mem)
					in
					(derefassign (memfind Addr(id) mem) r mem)
					end
            |   TSeq(t,cmd1,cmd2) => (table := (tableadd t mem !table);
					eval_cmd cmd2 (eval_cmd cmd1 mem))
            |   TIf(t,exp, cmd1, cmd2) => table := (tableadd t mem !table);
								let
									val cond = (eval_bexp exp mem)
								in
								if cond = Itv(Int(1),Int(1))
								then (eval_cmd cmd1 mem)
								else if cond = Itv(Int(0),Int(0))
									then (eval_cmd cmd2 mem)
									else (memjoin (eval_cmd cmd1 mem) (eval_cmd cmd2 mem))
								end
            |   TWhile(t,exp, cmd) => table := (tableadd t mem !table);
								 if (eval_bexp exp mem) <> Itv(Int(0),Int(0)) then
								(notsatisfy exp
								(narrowing t exp cmd
								(widening t exp cmd
								(widen mem (memjoin mem (eval_cmd cmd (satisfy exp mem)))) mem) mem))
								else mem

		and eval_bexp bexp mem =
			case bexp of
				Blop(blop, exp1, exp2) => (eval_blop blop (eval_exp exp1 mem) (eval_exp exp2 mem))
			|	Land(bexp1, bexp2) => numand((eval_bexp bexp1 mem),(eval_bexp bexp2 mem))
        and eval_exp exp mem =
            case exp of
                ReadInt => (Itv(NInfty,PInfty),Bottom)
            |   Num(n)  => (Itv(Int(n),Int(n)),Bottom)
            |   Var(id) => (memfind Addr(id) mem)
            |   Deref(id) => (deref (memfind Addr(id) mem) mem)
            |   AddrOf(id) => (Bottom,Adr([Addr(id)]))
            |   Bnop(bnop,exp1, exp2) => (eval_bnop bnop (eval_exp exp1 mem) (eval_exp exp2 mem))
            |   Unop(unop,exp) => (eval_unop unop (eval_exp exp mem))
            |   Malloc(exp) => (Itv(NInfty,PInfty),Bottom) (* Modify Here!!! *)
        and eval_bnop bop v1 v2 =
            case bop of
                Add => add(v1, v2)
        and eval_blop blop v1 v2 =
            case blop of
                Eq  => eq(v1, v2)
            |   Lt  => lt(v1, v2)
        and eval_unop uop v =
            case uop of
                UMinus => neg(v)


    in
		let 
        	val final_mem = (eval_cmd tpgm emptymem)
		in
			fn x => if x = 0 then [final_mem]
				else (Map.find x !table) handle Not_found => print_string "No memory\n";exit(1)
		end
    end

end
