(*
    SNU 4541.664A HW4 
*)
open Syn

structure Trans =
struct

fun trans_pgm pgm =
    let
		val pgm_point = ref 0
		fun inc_pt() = pgm_point := !pgm_point + 1

        fun trans_cmd cmd =
            case cmd of
                Skip => (inc_pt(); TSkip(!pgm_point))
            |   VarAssign(id,exp) => (inc_pt(); TVarAssign(!pgm_point, id,exp))
            |   DerefAssign(id,exp) => (inc_pt(); TDerefAssign(!pgm_point, id,exp))
            |   Seq(cmd1, cmd2) => (inc_pt();
							TSeq(!pgm_point, trans_cmd cmd1,trans_cmd cmd2))
            |   If(bexp, cmd1, cmd2) => 
                    (inc_pt(); TIf(!pgm_point, bexp,trans_cmd cmd1,trans_cmd cmd2))
            |   While(bexp, cmd) =>
                    (inc_pt(); TWhile(!pgm_point,bexp,trans_cmd cmd))

    in
        trans_cmd pgm
    end

end
